<template>
  <base-page class="item-create">
    <div class="page-header">
      <div class="row align-items-center">
        <div class="col">
          <h3 class="page-title" v-if="!isExpedicion">{{button}}</h3>
          <h3 class="page-title" v-if="isExpedicion">Validar Código</h3>

          <ul class="breadcrumb">
            <li class="breadcrumb-item">
              <router-link to="/admin/dashboard">{{
                $t('general.home')
              }}</router-link>
            </li>
            <li class="breadcrumb-item">
              <router-link to="/admin/ventas">ventas</router-link>
            </li>
            <li
              class="breadcrumb-item"
              v-if="
                $route.name === 'ventas.edit' && (isVendedor || isSuperAdmin)
              "
            >
              {{button}}
            </li>
            <li
              class="breadcrumb-item"
              v-if="$route.name === 'ventas.edit' && isExpedicion"
            >
              validar código
            </li>
          </ul>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col-md-12">
        <div class="card">
          <div class="card-body">
            <!-- <h4 class="card-title">Basic Info</h4> -->
            <div class="row" v-if="isExpedicion">
              <div class="col-12">
                <div class="form-group barcode-details">
                  <label>Ingrese el código</label>
                  <input v-model.trim="codigo_barra" class="form-control" /><br>
                  <button
                    class="btn btn-warning"
                    :loading="isLoading"
                    :disabled="isLoading"
                    type="submit"
                    @click="validarCodigo()"
                    @input="$v.codigo_barra.$touch()"

                  >
                    <i v-if="isLoading"  class="fas fa-spinner fa-spin"></i
                    >Validar
                  </button>
                  <!--<barcode v-bind:value="formData.codigo">
                      Generando código de barra ...
                    </barcode>-->
                </div>
                <!--<h3 v-if="validated==true" style="color:green">Código correcto</h3>-->
                <h3 v-if="validated==false" style="color:red">Código incorrecto</h3>
              </div>
            </div>
            <form v-if="!isExpedicion" @submit.prevent="submitUser">
              <div class="row">
                <div class="col-md-6">
                  <div v-if="!isEdit" class="form-group">
                    <label>Nombre del Cliente <span class="text-danger">*</span></label>
                    <input
                      type="text"
                      v-model.trim="formData.cliente"
                      autocomplete="off"
                      @input="$v.formData.cliente.$touch()"
                      class="form-control"
                    />
                    <!--<div class="invalid-feedback" v-if="$v.formData.codigo.$error">{{codigoError}}</div>-->
                  </div>
                  <div v-if="isEdit" class="form-group">
                    <label>Código <span class="text-danger">*</span></label>
                    <input
                      type="text"
                      disabled
                      v-model.trim="formData.codigo"
                      autocomplete="off"
                      @input="$v.formData.codigo.$touch()"
                      class="form-control"
                    />
                    <!--<div class="invalid-feedback" v-if="$v.formData.codigo.$error">{{codigoError}}</div>-->
                  </div>
                  <div v-if="isEdit" class="form-group">
                    <label>Producto <span class="text-danger">*</span></label>
                    <input
                      type="text"
                      v-model.trim="formData.nombre"
                      autocomplete="off"
                      @input="$v.formData.nombre.$touch()"
                      class="form-control"
                    />
                    <!--<div class="invalid-feedback" v-if="$v.formData.codigo.$error">{{codigoError}}</div>-->
                  </div>
                  <div v-if="!isEdit" class="form-group">
                    <label>Nombre del producto<span class="text-danger">*</span></label>
                      <multiselect v-model.trim="formData.value" :options="options" :multiple="true" :close-on-select="false" :clear-on-select="false" :preserve-search="true" placeholder="Seleccionar" label="nombre" track-by="nombre" :preselect-first="true">
                        <template slot="selection" slot-scope="{ values, search, isOpen }"><span class="multiselect__single" v-if="values.length &amp;&amp; !isOpen">{{ values.length }} opciones seleccionadas</span></template>
                      </multiselect>
                      <!--<pre class="language-json"><code>{{ value  }}</code></pre>-->
                    <!--<div class="invalid-feedback" v-if="$v.formData.nombre.$error">{{nombreError}}</div>-->
                  </div>
                  <div v-if="isEdit" class="form-group">
                    <label>Marca/Sku <span class="text-danger">*</span></label>
                    <input
                      type="text"
                      v-model.trim="formData.marca"
                      autocomplete="off"
                      @input="$v.formData.marca.$touch()"
                      class="form-control"
                    />
                    <!--<div class="invalid-feedback" v-if="$v.formData.marca.$error">{{marcaError}}</div>-->
                  </div>
                  <!--<div class="form-group">
                    <label>Stock</label>
                    <input
                      type="text"
                      disabled
                      v-model.trim="formData.stockact"
                      @input="$v.formData.stockact.$touch()"
                      autocomplete="off"
                      class="form-control"
                    />-->
                    <!--<div class="invalid-feedback" v-if="$v.formData.stockact.$error">{{stockactError}}</div>-->
                  <!--</div>-->
                  <div v-if="isEdit" class="form-group">
                    <label>Precio <span class="text-danger">*</span></label>
                    <input
                      type="text"
                      v-model.trim="formData.precio1"
                      autocomplete="off"
                      @input="$v.formData.precio1.$touch()"
                      class="form-control"
                    />
                    <!--<div class="invalid-feedback" v-if="$v.formData.precio1.$error">{{precio1Error}}</div>-->
                  </div>
                  <div  v-if="isEdit" class="form-group">
                    <label
                      >Observación <span class="text-danger">*</span></label
                    >
                    <input
                      type="text"
                      v-model.trim="formData.observa"
                      autocomplete="off"
                      @input="$v.formData.observa.$touch()"
                      class="form-control"
                    />
                    <!--<div class="invalid-feedback" v-if="$v.formData.observa.$error">{{observaError}}</div>-->
                  </div>
                  <button
                    class="btn btn-primary"
                    :loading="isLoading"
                    :disabled="isLoading"
                    type="submit"
                  >
                    <i v-if="isLoading" class="fas fa-spinner fa-spin"></i
                    >Guardar
                  </button>
                </div>
              </div>
            </form>
          </div>
        </div>
        <div class="card" v-if="validated">
          <div class="card-body"> 
            <div class="invoice-item invoice-table-wrap">
              <h3 class="report-title" style="color:green">Producto Validado</h3>
              <!--<div class="row">
                <div class="col-md-12">
                  <div class="table-responsive">
                    <table class="table total-report-table">
                      <tbody>
                      <tr>
                        <th>Nombre</th>
                        <td><span class="float-right">{{this.formData.nombre}}</span></td>
                      </tr>
                      <tr>
                        <th>Marca</th>
                        <td><span class="float-right">{{this.formData.marca}}</span></td>
                      </tr>
                      <tr>
                        <th>Precio</th>
                        <td><span class="float-right">{{this.formData.precio1}}</span></td>
                      </tr>
                      <tr>
                        <th>Cantidad</th>
                        <td><span class="float-right">{{this.formData.cantidad}}</span></td>
                      </tr>
                      <tr>
                        <th>Observación</th>
                        <td><span class="float-right">{{this.formData.observa}}</span></td>
                      </tr>
                      <tr>
                        <th>Estatus</th>
                        <td><span class="float-right">{{this.formData.status}}</span></td>
                      </tr>
                      </tbody>
                    </table>
                  </div>
                </div>
              </div>-->
              <br>
              <div class="col-12" v-if="validated">
                <form v-if="isExpedicion" @submit.prevent="submitEntregar">
                  <button
                    class="btn btn-primary text-right"
                    :loading="isLoading"
                    :disabled="isLoading"
                    type="submit"
                  >
                    <i v-if="isLoading" class="fas fa-spinner fa-spin"></i
                    >Entregar
                  </button>
                </form>
              </div>
            </div>            
          </div>
        </div>
      </div>
    </div>
  </base-page>
</template>

<script>

import { mapActions, mapGetters } from 'vuex'

import Multiselect from 'vue-multiselect'


const {
  required,
  minLength,
  email,
  numeric,
  minValue,
  maxLength,
  requiredIf,
  alpha,
} = require('vuelidate/lib/validators')
export default {
  components: {
    Multiselect
  },
  data() {
    return {
      isLoading: false,
      title: 'Add User',
      show: false,
      button:'Crear Orden',
      formData: {
        id:'',
        codbarra:'',
        codigo: '',
        nombre: '',
        marca: '',
        precio1: '',
        observa: '',
        cantidad: '',
        stockact: '',
        value:'',
        cliente:''
      },
      codigo_barra:'',
      validated:null,
      options:[],
      value:[]
    }
  },
  computed: {
    ...mapGetters('user', ['currentUser']), 
    isExpedicion() {
      return this.currentUser.roles == 'Expedicion'
    },
    isSuperAdmin() {
      return this.currentUser.role == 'super admin'
    },
    isVendedor() {
      return this.currentUser.roles == 'Vendedor'
    },
    pageTitle() {
      if (this.$route.name === 'ventas.edit') {
        return this.$t('ventas.edit_ventas')
      }
      return this.$t('users.new_user')
    },

    isEdit() {
      if (this.$route.name === 'ventas.edit') {
        this.button='Actualizar Orden/Producto'
        return true
      }
      return false
    },

    /*codigoError() {
      if (!this.$v.formData.codigo.$error) {
        return ''
      }
      if (!this.$v.formData.codigo.required) {
        return this.$t('validation.required')
      }
    
      /*if (!this.$v.formData.name.minLength) {
        return this.$tc(
          'validation.name_min_length',
          this.$v.formData.name.$params.minLength.min,
          { count: this.$v.formData.name.$params.minLength.min }
        )
      }*/
    /*},
    nombreError() {
      if (!this.$v.formData.nombre.$error) {
        return ''
      }
      if (!this.$v.formData.nombre.required) {
        return this.$t('validation.required')
      }
    
      /*if (!this.$v.formData.name.minLength) {
        return this.$tc(
          'validation.name_min_length',
          this.$v.formData.name.$params.minLength.min,
          { count: this.$v.formData.name.$params.minLength.min }
        )
      }*/
    /* },
    marcaError() {
      if (!this.$v.formData.marca.$error) {
        return ''
      }
      if (!this.$v.formData.marca.required) {
        return this.$t('validation.required')
      }
    
      /*if (!this.$v.formData.name.minLength) {
        return this.$tc(
          'validation.name_min_length',
          this.$v.formData.name.$params.minLength.min,
          { count: this.$v.formData.name.$params.minLength.min }
        )
      }*/
    /*},
    stockactError() {
      if (!this.$v.formData.stockact.$error) {
        return ''
      }
      if (!this.$v.formData.stockact.required) {
        return this.$t('validation.required')
      }
    
      /*if (!this.$v.formData.name.minLength) {
        return this.$tc(
          'validation.name_min_length',
          this.$v.formData.name.$params.minLength.min,
          { count: this.$v.formData.name.$params.minLength.min }
        )
      }*/
    /* },
    observaError() {
      if (!this.$v.formData.observa.$error) {
        return ''
      }
      if (!this.$v.formData.observa.required) {
        return this.$t('validation.required')
      }
    
      /*if (!this.$v.formData.name.minLength) {
        return this.$tc(
          'validation.name_min_length',
          this.$v.formData.name.$params.minLength.min,
          { count: this.$v.formData.name.$params.minLength.min }
        )
      }*/
    /*},
    cantidadError() {
      if (!this.$v.formData.cantidad.$error) {
        return ''
      }
      if (!this.$v.formData.cantidad.required) {
        return this.$t('validation.required')
      }
    
      /*if (!this.$v.formData.name.minLength) {
        return this.$tc(
          'validation.name_min_length',
          this.$v.formData.name.$params.minLength.min,
          { count: this.$v.formData.name.$params.minLength.min }
        )
      }*/
    // },
  },

  created() {
    /*if (!this.isSuperAdmin) {
      this.$router.push('/admin/dashboard')
    }*/
    this.cargarData()
    if (this.isEdit) {
      this.loadEditData()
    }
  },

  mounted() {
    this.$v.formData.$reset()
  },
  validations: {
    formData: {
      marca: {
        required,
      },
      observa: {
        required,
      },
      value: {
        required,
      },
      cliente: {
        required,
      },
      precio1: {
        required,
      },
    },
  },
  methods: {
    ...mapActions('ventas', ['fetchVenta', 'updateVenta', 'UpdateVentas','fetchVentas']),
    onCheck(val) {
      this.selected = val;
    },
    showDropdown() {
      this.show = !this.show
    },
    async cargarData(){
      const limite = {pages:'limit'}
      let response = await this.fetchVentas(limite)
      console.log('ventas',response.data.venta)
      if (response.data) {
        this.options = response.data.venta 
        console.log('options',this.options)

      }
    },
    async loadEditData() {
      let response = await this.fetchVenta(this.$route.params.id)
      if (response.data) {
        this.formData = { ...this.formData, ...response.data.articul }
      }
    },
    async submitEntregar() {
      try {
        let response
        this.isLoading = true
        response = await this.UpdateVentas(this.formData.id)
        console.log('data', response)

        window.toastr['success']('Orden Entregada')
        this.$router.push('/admin/ventas')
        this.isLoading = false
      } catch (err) {
        console.log('error entregar', err.response)
      }
    },
    async submitUser() {

      try {
        let response
        this.isLoading = true
        if (this.isEdit) {
          console.log('formData',this.formData)
          response = await this.updateVenta(this.formData)
          console.log('data data', response)
        }else{
          console.log('formData',this.formData)
          response = await this.updateVenta(this.formData)
          console.log('data data', response)
        }
          

        //if (response.data.success) {
        window.toastr['success']('Orden Actualizada')
        this.$router.push('/admin/ventas')
        this.isLoading = false
        //}
        /*if (response.data.error) {
            window.toastr['error'](this.$t('validation.email_already_taken'))
          }*/
        /*} else {
          response = await this.addUser(this.formData)
         
          if (response.data.success) {
            this.isLoading = false
            if (!this.isEdit) {
              window.toastr['success'](this.$tc('users.created_message'))
              this.$router.push('/admin/ventas')
              return true
            }
          }
        }*/
      } catch (err) {
        console.log('error', err)
        //if (err.response.data.errors.email) {
        this.isLoading = false
        //}
      }
    },
     validarCodigo(){
      
      if(this.codigo_barra.trim()==this.formData.codbarra.trim()){
        this.validated=true
      }else{
        this.validated=false
      }
    },
  },
}
</script>
<style src="vue-multiselect/dist/vue-multiselect.min.css"></style>

